<template id="rsat-popup-template">
    <style>
        .rsat-dialog-backdrop {
            position: fixed;
            height: 100%;
            width: 100%;
            background-color: rgba(0, 0, 0, 0);
            z-index: 1000;
            top: 0;
            left: 0;
            z-index: -1;
            background-color: rgba(0, 0, 0, 0.3);
            z-index: 1000;
        }

        .rsat-hide {
            display: none;
        }

        .rsat-show {
            display: block;
        }

        .rsat-dialog {
            position: fixed;
            height: 75%;
            overflow-y: auto;
            z-index: 10001;
            box-shadow: 0 2px 2px 0 rgba(0, 0, 0, .14), 0 3px 1px -2px rgba(0, 0, 0, .2), 0 1px 5px 0 rgba(0, 0, 0, .12);
            background-color: white;
        }

        .rsat-at-center {
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
        }

        .rsat-at-top-left {
            top: 0%;
            left: 0%;
        }

        .rsat-at-top-right {
            top: 0%;
            right: 0%;
        }

        .rsat-at-bottom-left {
            bottom: 0%;
            left: 0%;
        }

        .rsat-at-bottom-right {
            bottom: 0%;
            right: 0%;
        }
    </style>
    <div class="rsat-dialog" id="rsat-popup-container">
        <slot></slot>
    </div>
    <div class="rsat-dialog-backdrop rsat-hide" id="rsat-popup-backdrop"></div>
</template>
<script>
    var currentScript = document.currentScript;
    class rsatPopup extends HTMLElement {
        // A getter/setter for an pos property.
        get pos() {
            return this.getAttribute('pos');
        }
        set pos(val) {
            if (val) {
                this.setAttribute('pos', val);
            }
        }

        get backdrop() {
            return this.getAttribute('backdrop');
        }
        set backdrop(val) {
            if (val) {
                this.setAttribute('backdrop', val);
            }
        }

        get show() {
            return this.getAttribute('show');
        }
        set show(val) {
            if (val) {
                this.setAttribute('show', val);
            }
        }

        //watch for attributes changes
        static get observedAttributes() { return ['pos', 'backdrop', 'show']; }
        // Respond to attribute changes.
        attributeChangedCallback(attr, oldValue, newValue) {
            if (attr == "pos" && this.shadowDOM) {
                var popupContainer = this.shadowDOM.querySelector('#rsat-popup-container');
                if (popupContainer) {
                    popupContainer.classList.remove("rsat-at-" + oldValue);
                    popupContainer.classList.add("rsat-at-" + newValue);
                }

            }
            //for showing or hiding
            if (attr == "show" && this.shadowDOM) {
                if (newValue && newValue.toLocaleLowerCase() == 'true') {
                    //show popup
                    if (this.backdrop && this.backdrop.toLocaleLowerCase() == 'true') {
                        this.showPopup(true);
                    } else {
                        this.showPopup(false);
                    }
                } else {
                    this.hidePopup();
                }
            }
        }

        constructor() {
            super();
            this.initShadowDom();
        }
        initShadowDom() {
            const mainDoc = currentScript.ownerDocument;
            let shadowRoot = this.attachShadow({ mode: 'open' });
            const t = mainDoc.querySelector('#rsat-popup-template');
            const instance = t.content.cloneNode(true);
            shadowRoot.appendChild(instance);
            this.shadowDOM = shadowRoot;


        }

        showPopup(backdrop) {
            if (backdrop) {
                this.showBackdrop();
            } else {
                this.hideBackdrop();
            }
            this.showPopupContainer();
        }
        hidePopup() {
            this.hidePopupContainer();
            this.hideBackdrop();

        }

        showPopupContainer() {
            var popupContainer = this.shadowDOM.querySelector('#rsat-popup-container');
            popupContainer.classList.remove("rsat-hide");
            popupContainer.classList.add("rsat-show");

        }
        hidePopupContainer() {
            var popupContainer = this.shadowDOM.querySelector('#rsat-popup-container');
            popupContainer.classList.remove("rsat-show");
            popupContainer.classList.add("rsat-hide");
        }

        showBackdrop() {
            var backdrop = this.shadowDOM.querySelector('#rsat-popup-backdrop');
            backdrop.classList.remove("rsat-hide");
            backdrop.classList.add("rsat-show");

        }
        hideBackdrop() {
            var backdrop = this.shadowDOM.querySelector('#rsat-popup-backdrop');
            backdrop.classList.remove("rsat-show");
            backdrop.classList.add("rsat-hide");

        }


    }
    window.customElements.define('rsat-popup', rsatPopup);

</script>
